<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_CruisePriceInformation StructType
 * @subpackage Structs
 */
class JP_CruisePriceInformation extends AbstractStructBase
{
    /**
     * The Components
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_CruiseComponent
     */
    public $Components;
    /**
     * The Category
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_CruiseCategory
     */
    public $Category;
    /**
     * The AdditionalElements
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_CruiseAdditionalElements
     */
    public $AdditionalElements;
    /**
     * The Prices
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_Price
     */
    public $Prices;
    /**
     * Constructor method for JP_CruisePriceInformation
     * @uses JP_CruisePriceInformation::setComponents()
     * @uses JP_CruisePriceInformation::setCategory()
     * @uses JP_CruisePriceInformation::setAdditionalElements()
     * @uses JP_CruisePriceInformation::setPrices()
     * @param \ArrayType\ArrayOfJP_CruiseComponent $components
     * @param \StructType\JP_CruiseCategory $category
     * @param \StructType\JP_CruiseAdditionalElements $additionalElements
     * @param \ArrayType\ArrayOfJP_Price $prices
     */
    public function __construct(\ArrayType\ArrayOfJP_CruiseComponent $components = null, \StructType\JP_CruiseCategory $category = null, \StructType\JP_CruiseAdditionalElements $additionalElements = null, \ArrayType\ArrayOfJP_Price $prices = null)
    {
        $this
            ->setComponents($components)
            ->setCategory($category)
            ->setAdditionalElements($additionalElements)
            ->setPrices($prices);
    }
    /**
     * Get Components value
     * @return \ArrayType\ArrayOfJP_CruiseComponent|null
     */
    public function getComponents()
    {
        return $this->Components;
    }
    /**
     * Set Components value
     * @param \ArrayType\ArrayOfJP_CruiseComponent $components
     * @return \StructType\JP_CruisePriceInformation
     */
    public function setComponents(\ArrayType\ArrayOfJP_CruiseComponent $components = null)
    {
        $this->Components = $components;
        return $this;
    }
    /**
     * Get Category value
     * @return \StructType\JP_CruiseCategory|null
     */
    public function getCategory()
    {
        return $this->Category;
    }
    /**
     * Set Category value
     * @param \StructType\JP_CruiseCategory $category
     * @return \StructType\JP_CruisePriceInformation
     */
    public function setCategory(\StructType\JP_CruiseCategory $category = null)
    {
        $this->Category = $category;
        return $this;
    }
    /**
     * Get AdditionalElements value
     * @return \StructType\JP_CruiseAdditionalElements|null
     */
    public function getAdditionalElements()
    {
        return $this->AdditionalElements;
    }
    /**
     * Set AdditionalElements value
     * @param \StructType\JP_CruiseAdditionalElements $additionalElements
     * @return \StructType\JP_CruisePriceInformation
     */
    public function setAdditionalElements(\StructType\JP_CruiseAdditionalElements $additionalElements = null)
    {
        $this->AdditionalElements = $additionalElements;
        return $this;
    }
    /**
     * Get Prices value
     * @return \ArrayType\ArrayOfJP_Price|null
     */
    public function getPrices()
    {
        return $this->Prices;
    }
    /**
     * Set Prices value
     * @param \ArrayType\ArrayOfJP_Price $prices
     * @return \StructType\JP_CruisePriceInformation
     */
    public function setPrices(\ArrayType\ArrayOfJP_Price $prices = null)
    {
        $this->Prices = $prices;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\JP_CruisePriceInformation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
